CREATE TABLE IF NOT EXISTS `#__vtemgallery` (
  `id` int(5) NOT NULL AUTO_INCREMENT,
  `ordering` int(4) NOT NULL DEFAULT '1',
  `name` varchar(255) NOT NULL,
  `alias` varchar(256) NOT NULL,
  `profile` int(4) NOT NULL,
  `parent` int(7) NOT NULL DEFAULT '0',
  `menu_image_filename` varchar(128) NOT NULL,
  `menu_description` text NOT NULL,
  `gallery_description` text NOT NULL,
  `user` int(7) NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `moderate` int(1) NOT NULL DEFAULT '1',
  `hits` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

CREATE TABLE IF NOT EXISTS `#__vtemgallery_img` (
  `id` int(5) NOT NULL AUTO_INCREMENT,
  `gallery_id` int(5) NOT NULL,
  `ordering` int(5) NOT NULL DEFAULT '1',
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `filename` varchar(128) NOT NULL,
  `description` text NOT NULL,
  `tags` text NOT NULL,
  `alt_text` varchar(255) NOT NULL,
  `link` varchar(255) NOT NULL,
  `target_blank` int(1) NOT NULL DEFAULT '1',
  `user` int(11) NOT NULL,
  `access` int(2) NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '1',
  `moderate` int(1) NOT NULL DEFAULT '1',
  `rotation` int(4) NOT NULL DEFAULT '0',
  `hits` int(11) NOT NULL,
  `menu_image` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `gallery_id` (`gallery_id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;


CREATE TABLE IF NOT EXISTS `#__vtemgallery_profiles` (
  `id` int(5) NOT NULL AUTO_INCREMENT,
  `ordering` int(4) NOT NULL DEFAULT '1',
  `name` varchar(255) NOT NULL,
  `img_quality` int(3) NOT NULL DEFAULT '80',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `max_width` int(4) NOT NULL DEFAULT '600',
  `max_height` int(4) NOT NULL DEFAULT '400',
  `preload` int(1) NOT NULL DEFAULT '1',
  `magnify` int(1) NOT NULL DEFAULT '1',
  `show_thumbs` int(1) NOT NULL DEFAULT '1',
  `thumb_width` int(4) NOT NULL DEFAULT '90',
  `thumb_height` int(4) NOT NULL DEFAULT '90',
  `images_per_row` int(4) NOT NULL DEFAULT '0',
  `scroll_boundary` int(4) NOT NULL DEFAULT '200',
  `gallery_des_position` varchar(10) NOT NULL DEFAULT 'below',
  `style` varchar(128) NOT NULL,
  `enable_slideshow` int(1) NOT NULL DEFAULT '1',
  `show_descriptions` int(1) NOT NULL DEFAULT '1',
  `show_search` int(1) NOT NULL DEFAULT '0',
  `acl_cat_menu` varchar(255) NOT NULL DEFAULT '2',
  `acl_cat_display` varchar(255) NOT NULL DEFAULT '2',
  `acl_cat_view` varchar(255) NOT NULL DEFAULT '1',
  `acl_cat_edit` varchar(255) NOT NULL DEFAULT '1',
  `acl_cat_delete` varchar(255) NOT NULL DEFAULT '1',
  `acl_cat_publish` varchar(255) NOT NULL DEFAULT '1',
  `acl_cat_order` varchar(255) NOT NULL DEFAULT '1',
  `acl_upload` varchar(255) NOT NULL DEFAULT '1',
  `acl_photo_view` varchar(255) NOT NULL DEFAULT '1',
  `acl_photo_edit` varchar(255) NOT NULL DEFAULT '1',
  `acl_photo_del` varchar(255) NOT NULL DEFAULT '1',
  `acl_photo_publish` varchar(255) NOT NULL DEFAULT '1',
  `acl_photo_ordering` varchar(255) NOT NULL DEFAULT '1',
  `show_cat_title` int(1) NOT NULL DEFAULT '0',
  `crop_menu` int(1) NOT NULL DEFAULT '1',
  `refresh_mode` varchar(24) NOT NULL DEFAULT 'javascript',
  `show_tags` int(1) NOT NULL DEFAULT '0',
  `share_facebook` int(1) NOT NULL DEFAULT '0',
  `menu_image_defaults` int(1) NOT NULL DEFAULT '1',
  `thumb_pagination` int(1) NOT NULL DEFAULT '0',
  `thumb_pagination_amount` int(4) NOT NULL DEFAULT '20',
  `cats_per_row` int(11) NOT NULL DEFAULT '1',
  `show_cats_title` tinyint(1) NOT NULL DEFAULT '1',
  `show_cats_desc` tinyint(1) NOT NULL DEFAULT '1',
  `show_image_title` tinyint(1) NOT NULL DEFAULT '1',
  `thumbnail_style` varchar(20) NOT NULL,
  `lbox_control` tinyint(1) NOT NULL DEFAULT '1',
  `lbox_period` varchar(7) NOT NULL DEFAULT '3000',
  `lbox_crop_thumbs` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;


INSERT INTO `#__vtemgallery_profiles` (`id`, `ordering`, `name`, `img_quality`, `published`, `max_width`, `max_height`, `preload`, `magnify`, `show_thumbs`, `thumb_width`, `thumb_height`, `images_per_row`, `scroll_boundary`, `gallery_des_position`, `style`, `enable_slideshow`, `show_descriptions`, `show_search`, `acl_cat_menu`, `acl_cat_display`, `acl_cat_view`, `acl_cat_edit`, `acl_cat_delete`, `acl_cat_publish`, `acl_cat_order`, `acl_upload`, `acl_photo_view`, `acl_photo_edit`, `acl_photo_del`, `acl_photo_publish`, `acl_photo_ordering`, `show_cat_title`, `crop_menu`, `refresh_mode`, `show_tags`, `share_facebook`, `menu_image_defaults`, `thumb_pagination`, `thumb_pagination_amount`, `cats_per_row`, `show_cats_title`, `show_cats_desc`, `show_image_title`, `thumbnail_style`, `lbox_control`, `lbox_period`, `lbox_crop_thumbs`) VALUES
(1, 1, 'default item', 80, 1, 600, 400, 1, 1, 1, 150, 100, 4, 150, 'below', 'style1', 1, 1, 0, '2', '2', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', 0, 0, 'javascript', 0, 0, 1, 0, 20, 3, 1, 1, 1, 'basic', 1, '3000', 0);
