<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

class vtemphotoModelVtemphoto extends vtembaseModel
{
    protected $context = 'vtemphoto';
	protected $tablename = 'vtemgallery_img';
	protected $filterOrderDefault = 'ordering';
	
	function __construct($task)
	{
		parent::__construct();
		$this->reorderClause = 'gallery_id = '.(int)$this->_catid;
    }
	
	function _buildQuery()
	{
		$where		= $this->_buildContentWhere();
		$orderby	= $this->_buildContentOrderBy();
        
        $query = 'SELECT '.
		'#__vtemgallery_img.*, '.
		'#__vtemgallery.name, '.
		'#__vtemgallery_profiles.max_width, #__vtemgallery_profiles.max_height, #__vtemgallery_profiles.thumb_width, '.
		'#__vtemgallery_profiles.thumb_height, #__vtemgallery_profiles.img_quality '.
		'FROM #__vtemgallery_img '.
		'INNER JOIN #__vtemgallery ON #__vtemgallery.id = #__vtemgallery_img.gallery_id '.
		'INNER JOIN #__vtemgallery_profiles ON #__vtemgallery_profiles.id = #__vtemgallery.profile '.
		$where . $orderby;
		
		return $query;
	}
	
	function _buildContentWhere()
	{
		global $mainframe, $option;
		
		$catid		        = $mainframe->getUserStateFromRequest( $this->context.'.catid',		        'catid',		    0,				'int' );
		$filter_state		= $mainframe->getUserStateFromRequest( $this->context.'.filter_state',		'filter_state',		'',				'word' );
		$filter_order		= $mainframe->getUserStateFromRequest( $this->context.'.filter_order',		'filter_order',		'ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $this->context.'.filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$search				= $mainframe->getUserStateFromRequest( $this->context.'.search',			    'search',			'',				'string' );
		$search				= JString::strtolower( $search );
//var_dump($_POST);die;
		$where = array();
		$searchArray = array();
		if( !empty($catid) )
		{
        	$where[] = 'gallery_id = '.(int) $catid;
		}
		
        if ($search) 
		{
		    $searchArray[] = 'description LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $search, true ).'%', false );
			$searchArray[] = 'filename LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $search, true ).'%', false );
			$searchArray[] = 'tags LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $search, true ).'%', false );
			$searchArray[] = 'alt_text LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $search, true ).'%', false );
			$searchClauses = implode( ' OR ', $searchArray ) ;
			$where[] = '('.$searchClauses.')';
		}
		
		if ($filter_state) 
		{
			if ( $filter_state == 'P' ) 
			{
				$where[] = '#__vtemgallery_img.published = 1';
			} 
			else if ($filter_state == 'U' ) 
			{
				$where[] = '#__vtemgallery_img.published = 0';
			}
		}

		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );

		return $where;
	}
	
	function getDataFrontend()
	{
	    $query = 'SELECT * from #__vtemgallery_img WHERE gallery_id = '.(int)$this->_catid.' ORDER BY ordering';
    	$this->_db->setQuery($query);
    	$this->_data = $this->_db->loadObjectlist();
		
    	$count = count($this->_data);
    	
		for($i=0; $i<$count; $i++ )
		{
			if( !$this->authenticate('acl_photo_view', $this->_data[$i]->id) )
			{
				unset($this->_data[$i]);
			}
		}
		$this->_data = array_values($this->_data);
    	
    	return $this->_data;
	}
    
    function save($post)
	{
	    $row =& $this->getTable('vtemgallery_img');
	    
	    $row->id = $this->_id;
	    if (!$row->bind($post)) 
		{
			JError::raise(2, 500, $this->_db->getErrorMsg());
			return false;
		}

		$row->description = JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWHTML );
		$row->alt_text = htmlspecialchars($row->alt_text, ENT_QUOTES);

		if (!$row->store()) 
		{
			JError::raise(2, 500, $this->_db->getErrorMsg());
			return false;
		}
		
		$query = 'SELECT gallery_id, ordering from #__vtemgallery_img WHERE id = '.(int)$this->_id;
    	$this->_db->setQuery($query);
    	$currentRow = $this->_db->loadObject();
		
		$nextOrdering = $currentRow->ordering + 1;
		$query = 'SELECT id from #__vtemgallery_img WHERE gallery_id = '.(int)$currentRow->gallery_id.' AND ordering = '.(int)$nextOrdering.' LIMIT 1';
    	$this->_db->setQuery($query);
    	$nextRow = $this->_db->loadObject();
    	
		return $nextRow->id;
	}
	
	function store($fileData)
	{
	    $row =& $this->getTable('vtemgallery_img');
		$user =& JFactory::getUser();
		$configArray =& JComponentHelper::getParams('com_vtemgallery');
		
		$row->id = null;
        $row->user = $user->id;
		$row->target_blank = $configArray->get('target_blank', 1);
		$row->access = $configArray->get('new_image_access', 0);
		$row->published = $configArray->get('new_image_published', 1);
		$row->gallery_id = (int)$this->_catid;
		$row->filename = $fileData['filename'];
		$row->moderate = $configArray->get('moderate_img', 0) == 0 || VTEM_BACKEND == true ? 1 : 0;

		$firstLast = $configArray->get('new_image_ordering', 'last');
		$row->ordering = $firstLast == 'first' ? 0 : $row->getNextOrder('gallery_id = '.(int)$this->_catid );
		
		if( isset($fileData['exif_des']) )
		{
			$row->description = strlen($fileData['exif_des']) > 0 ? $fileData['exif_des'] : $row->description;
		}
		
		if( isset($fileData['iptc_des']) )
		{
			$row->description = strlen($fileData['iptc_des']) > 0 ? $fileData['iptc_des'] : $row->description;
		}
				
        if( !$row->store() )
		{
		  	echo $row->getError();
		  	return false;
		}

		//if the image was added to the start of the order, we need to reorder
		if($firstLast == 'first')
	    {
	       $row->reorder('gallery_id = '.(int)$this->_catid );
	    }
	    
	    $mainframe =& JFactory::getApplication();
	    $sessionValue = $mainframe->getUserState('com_vtemgallery.moderateimg'.$row->gallery_id, 0);
	   
	    if(VTEM_BACKEND == false && empty($sessionValue) )
	    {
			if($configArray->get('notify_new_image', 0) == 1)
			{
				$this->notify('image', $row->id);
				
				$mainframe->setUserState( 'com_vtemgallery.moderateimg'.$row->gallery_id, 1);
			}
	    }
	    
	    return true;
	}
	
	function remove()
	{
	    $cid = JRequest::getVar( 'cid', array(), '', 'array' );
		JArrayHelper::toInteger($cid);
		
		for($i=0; $i<count($cid); $i++)
		{
		    $query = 'SELECT filename FROM #__vtemgallery_img WHERE id = '.(int)$cid[$i];
            $this->_db->setQuery($query);
            $this->_photo = $this->_db->loadObject();
		
    		$query = 'SELECT filename FROM #__vtemgallery_img WHERE filename = '.$this->_db->Quote($this->_photo->filename);
    		$this->_db->setQuery($query);
    		$this->_db->query();
    		$numRows = $this->_db->getNumRows();
    		$deleteOrig = $numRows > 1 ? false: true;
    		
    	    igFileHelper::deleteImage($this->_photo->filename, $deleteOrig);
		    
    		//delete the photo row(s)
    		$query = 'DELETE FROM #__vtemgallery_img WHERE id = '.(int)$cid[$i];
    		$this->_db->setQuery($query);
    		if(!$this->_db->query())
    		{
    			$this->setError($this->_db->getErrorMsg());
    			return false;
    		}
    		
		}
		
		$row =& $this->getTable('vtemgallery_img');
    	$row->reorder('gallery_id = '.(int)$this->_catid );
		
		return true;
	}
	
	function copy_move()
	{
	    $targetCat = JRequest::getInt('cat_id_copy_move');
	    if($targetCat == 0)
        {
            JError::raise(2, 500, JText::_('NO TARGET CATEGORY SELECTED') ); 
        }
        
        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		
		$copyMove = JRequest::getWord('copy_move','copy');
		
		
        for($i=0; $i<count($cid); $i++)
		{
			$row =& $this->getTable('vtemgallery_img');
            $row->load($cid[$i]);
            $origId = $row->id;
            
            $row->id = null;
            $row->gallery_id = (int)$targetCat;
            $row->ordering = $row->getNextOrder('gallery_id = '.(int)$targetCat );
		   
            if(!$row->store())
            {
               $this->setError($this->_db->getErrorMsg());
               return false;
            }
            
            $newId = $row->id;
                        
            if($copyMove == 'move')
            {
                $query = 'DELETE FROM #__vtemgallery_img WHERE id = '.(int)$origId;
        		$this->_db->setQuery($query);
        		if(!$this->_db->query())
        		{
        			$this->setError($this->_db->getErrorMsg());
        			return false;
        		}        		
            }
		}
		return true;
	}
	
	function rotate()
	{
		$id = JRequest::getInt('id', 0);
		$rvalue = JRequest::getInt('rvalue', 0);
		
		$row =& $this->getTable('vtemgallery_img');
		$row->load( (int)$id );
		
		if($rvalue == 0)
		{
			if($row->rotation == 0)
			{
				$row->rotation = 270;
			}
			else
			{
				$row->rotation = $row->rotation - 90;
			}
		}
		else
		{
			if($row->rotation == 270)
			{
				$row->rotation = 0;
			}
			else
			{
				$row->rotation = $row->rotation + 90;
			}
		}
		
		if (!$row->store()) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		return true;
	}
	
	function addHit($id)
	{
		$row =& $this->getTable('vtemgallery_img');
		$row->load( (int)$id );
		$row->hits = $row->hits + 1;
		if(!$row->store())
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		return true;
	}
	
	function assignMenuImage()
	{
		$id = JRequest::getInt('id', 0);
		$catid = JRequest::getInt('catid', 0);
		$cvalue = JRequest::getInt('cvalue', 0);
		
		$query = 'UPDATE #__vtemgallery_img SET menu_image = 0 WHERE gallery_id = '.(int)$catid;
		$this->_db->setQuery($query);
		if(!$this->_db->query())
    	{
    		$this->setError($this->_db->getErrorMsg());
    		return false;
    	}
    	
		$query = 'UPDATE #__vtemgallery_img SET menu_image = '.(int)$cvalue.' WHERE id = '.(int)$id;
		$this->_db->setQuery($query);
		if(!$this->_db->query())
    	{
    		$this->setError($this->_db->getErrorMsg());
    		return false;
    	}
		
    	return true;
	}
	
	function reportImage()
	{
		$id = JRequest::getInt('id', 0);
		$text = JRequest::getVar('report_textarea', '');
		$this->notify('report', $id, $text);
		return true;
	}
	
	function move($direction)
	{
		$row =& $this->getTable($this->tablename);
		if (!$row->load($this->_id)) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		//var_dump($row);

		if (!$row->move($direction) ) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		//var_dump($row);
		
		$row->reorder('gallery_id = '.(int)$row->gallery_id);
//var_dump($row);die;
		return true;
	}
}