<?php
defined('_JEXEC') or die('Restricted access');

class vtemcategoriesController extends vtembaseController
{
	
    function __construct($config = array())
	{
		parent::__construct($config);
		
        $this->redirect = 'index.php?option=com_vtemgallery&controller=vtemcategories&Itemid='.JRequest::getInt('Itemid');
		$this->addModelPath($path = VTEM_ADMINISTRATOR_COMPONENT.DS.'models');
		$this->registerTask('apply', 'save');
	}
	
	function display()
	{
	    $view = JRequest::getCmd('view', 'vtemcategories');
	    $cid = JRequest::getVar('cid', array(0), '', 'array');
	    $model = $this->getModel();
	    
	    if($view == 'add_edit_category')
	    {
	    	if($cid[0] > 0)
	    	{
		    	if( !$model->authenticate('acl_cat_edit', (int)$cid[0]) )
	    		{
	    			echo JText::_('RESTRICTED ACCESS');
	    		    return false;
	    		}
	    	}
	    	else
	    	{
		    	if( !$model->authenticate() )
	    		{
	    		    return false;
	    		}
	    	}
	    }
	    
		if($view == 'vtemcategories')
    	{
	    	if( !$model->authenticate() )
    		{
    		    return false;
    		}
    	}
		
		parent::display();
	}
	
	function save()
	{
		$post	= JRequest::get('post');
		$model = $this->getModel();
		$configArray =& JComponentHelper::getParams('com_vtemgallery');
		
		if( isset( $post['save_category_cancel'] ) )
		{
			$this->setRedirect('index.php?option=com_vtemgallery&controller=vtemcategories&Itemid='.JRequest::getInt('Itemid') );
			return;
		}
		
		if(isset( $post['cid'][0]) )
		{
		    if( !$model->authenticate('acl_cat_edit', (int)$post['cid'][0]) )
			{
				echo JText::_('RESTRICTED ACCESS');
			    return false;
			}
		}
		else
		{
			if( !$model->authenticate() )
			{
			    return false;
			}
		}
	    
	    if(strlen($_FILES['upload_image']['name']) > 2 )
		{
            $fileName = $_FILES['upload_image']['name'];
            $tmpPath = $_FILES['upload_image']['tmp_name'];
            $uploadError = $_FILES['upload_image']['error'];
            
    	    if(!$fileArray = igFileHelper::processUploadedImage($fileName, $tmpPath, $uploadError, 'vtemgallery', true) )
            {
                return false;
            }
            $post['menu_image_filename'] = $fileArray['filename'];
            
            $configArray =& JComponentHelper::getParams('com_vtemgallery');
            
            if($configArray->get('import_exif_data', 0) == 1)
            {
                $post['menu_description'] = $fileArray['exif_des'];
            }
		}
	    
		$model = $this->getModel('vtemcategories');

		if ($model->save($post)) 
		{
			$msg = $configArray->get('moderate_cat', 0) == 0 ? JText::_('CATEGORY SAVED') : JText::_('YOUR ADDITION WILL DISPLAY');
		}

		$this->setRedirect('index.php?option=com_vtemgallery&controller=vtemcategories&Itemid='.JRequest::getInt('Itemid'), $msg);
	}
    
    function remove()
	{
	    $cid = JRequest::getVar('cid', array(0), '', 'array');
        $model = $this->getModel();
        
        if( !$model->authenticate('acl_cat_delete', (int)$cid[0]) )
		{
			echo JText::_('RESTRICTED ACCESS');
		    return false;
		}
		
		if( !$model->remove() ) 
		{
			JError::raise(2, 500, $model->getError(true) );
		}

		$this->setRedirect( 'index.php?option=com_vtemgallery&controller=vtemcategories&Itemid='.JRequest::getInt('Itemid'), JText::_( 'CATEGORY DELETED' ) );
	}
	
	function publish()
	{
	    $cid = JRequest::getVar('cid', array(0), '', 'array');
	    $model = $this->getModel();
        if( !$model->authenticate('acl_cat_publish', (int)$cid[0]) )
		{
			echo JText::_('RESTRICTED ACCESS');
		    return false;
		}
	    
        if(!$model->publish(1)) 
		{
			JError::raiseError(2, 500,$model->getError(true) );
		}

		$this->setRedirect( 'index.php?option=com_vtemgallery&controller=vtemcategories&Itemid='.JRequest::getInt('Itemid') );
	}

    function unpublish()
	{
	    $cid = JRequest::getVar('cid', array(0), '', 'array');
        $model = $this->getModel();
        
        if( !$model->authenticate('acl_cat_publish', (int)$cid[0]) )
		{
			echo JText::_('RESTRICTED ACCESS');
		    return false;
		}
		
		if(!$model->publish(0)) 
		{
			JError::raiseError(2, 500, $model->getError(true) );
		}

		$this->setRedirect( 'index.php?option=com_vtemgallery&controller=vtemcategories&Itemid='.JRequest::getInt('Itemid') );
	}
	
	function saveorder()
	{
	    $model = $this->getModel();
	    $cid = JRequest::getVar('cid', array(0), '', 'array');
	    
	    for($i=0; $i<count($cid); $i++)
	    {
	        if( !$model->authenticate('acl_cat_order', (int)$cid[$i]) )
			{
				echo JText::_('RESTRICTED ACCESS');
			    return false;
			}
	    }
	    
		if( !$model->saveorder() ) 
		{
			JError::raiseError(2, 500, $model->getError(true) );
		}

		$msg = JText::_( 'New ordering saved' );
		$this->setRedirect( 'index.php?option=com_vtemgallery&controller=vtemcategories&Itemid='.JRequest::getInt('Itemid'), $msg );
	}
}