<?php
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class vtemcategoryController extends JController
{
    function __construct($config = array())
	{
		$config['base_path'] = JPATH_SITE.DS.'components'.DS.'com_vtemgallery';

		JRequest::setVar( 'view', $this->_name );
		JRequest::setVar( 'source', $config['source'] );

		$this->addModelPath($path = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_vtemgallery'.DS.'models');

		parent::__construct( $config );
	}

	function download()
	{
	    $linkSource = JRequest::getCmd('type', 'main');
	    
	    $model = new vtembaseModel();
	    $photo = $model->getPhoto( JRequest::getInt('id', 0));
	    $category = $model->getCategory($photo->gallery_id);
	    $profile = $model->getProfile($category->profile);
	    
	    if($linkSource == 'lbox')
	    {
	        $imageType = $profile->lbox_download_image;
	    }
	    else
	    {
	        $imageType = $profile->download_image;
	    }
	    
	    if($imageType == 'none')
	    {
	        echo JText::_('RESTRICTED ACCESS');
	        return;
	    }
	    
	    switch($imageType)
	    {
            case 'large':
                $fileDetails = igFileHelper::originalToResized($photo->filename, $profile->max_width, $profile->max_height, $profile->img_quality, 0);
		        
		        $path = VTEM_RESIZE_PATH.DS.$fileDetails['folderName'].DS.$fileDetails['fullFileName'];
		        break;
    		    
            default:
                $increment = igFileHelper::getIncrementFromFilename($photo->filename);
	            $folderName = igFileHelper::getFolderName($increment);
	            
	            $path = VTEM_ORIG_PATH.DS.$folderName.DS.$photo->filename;
        }

        
        if( file_exists($path) ) 
        {
            preg_match_all('/-[0-9]+/', $photo->filename, $matches);
            $filename =  str_replace( $matches[0][0], '', $photo->filename );
            
	        header('Content-Description: File Transfer');
            header('Content-Type: application/octet-stream');
            header('Content-Disposition: attachment; filename='.$filename );
            header('Content-Transfer-Encoding: binary');
            header('Expires: 0');
            header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
            header('Pragma: public');
            header('Content-Length: ' . filesize($path));
            ob_clean();
            flush();
            readfile($path);
            exit;
        }
        else
        {
            echo JText::_('FILE NOT EXIST');
        }
	}
	
	function joomcomment()
	{
		$id = JRequest::getInt('id', 0);
		include_once(JPATH_PLUGINS.DS.'content'.DS.'jom_comment_bot.php');
		echo jomcomment($id, 'com_vtemgallery');
	}

}