<?php
defined('_JEXEC') or die('Restricted access');

class vtemPhotoController extends vtembaseController
{
    function __construct($config = array())
	{
		parent::__construct($config);
		
		$this->addModelPath($path = VTEM_ADMINISTRATOR_COMPONENT.DS.'models');
		$this->registerTask('apply', 'save');
	}
	
	function display()
	{
		$view = JRequest::getCmd('view', 'vtemphoto');
		$model = $this->getModel();
	    
	    if($view == 'edit_photo')
	    {
	    	$cid = JRequest::getVar('cid', array(0), '', 'array');
	    	
	        if( !$model->authenticate('acl_photo_edit', (int)$cid[0]) )
    		{
    			echo JText::_('RESTRICTED ACCESS');
    		    return false;
    		} 
	    }
		
	    if($view == 'vtemphoto')
	    {
		    $catid = JRequest::getInt('catid', 0);
	        
	        if( !$model->authenticate('acl_cat_view', $catid) )
			{
				echo JText::_('RESTRICTED ACCESS');
			    return false;
			}
	    }
		
		parent::display();
	}

	function save()
	{
	    $post	= JRequest::get('post');
	    
		if( isset( $post['save_photo_cancel'] ) )
		{
			$this->setRedirect('index.php?option=com_vtemgallery&controller=vtemphoto&catid='.$post['catid'].'&Itemid='.JRequest::getInt('Itemid') );
			return;
		}

		$model = $this->getModel();
		
		if( !$model->authenticate('acl_photo_edit', (int)$post['cid'][0]) )
		{
			echo JText::_('RESTRICTED ACCESS');
		    return false;
		}
		
		$nextOrder = $model->save($post);
		
		$url = 'index.php?option=com_vtemgallery&controller=vtemphoto&catid='.$post['catid'].'&Itemid='.JRequest::getInt('Itemid'); 
		
		if( isset( $post['save_next_photo_submit'] ) )
		{
			$url = empty($nextOrder) ? $url : 'index.php?option=com_vtemgallery&controller=vtemphoto&view=edit_photo&cid[]='.$nextOrder.'&Itemid='.JRequest::getInt('Itemid');
		}
		
		
		$this->setRedirect($url, JText::_( 'PHOTO DETAILS SUCCESSFULLY SAVED' ));
	}
    
    function remove()
	{
	    $cid = JRequest::getVar('cid', array(0), '', 'array');
		$model = $this->getModel();
        
        if( !$model->authenticate('acl_photo_del', (int)$cid[0]) )
		{
			echo JText::_('RESTRICTED ACCESS');
		    return false;
		}
		
		if(!$model->remove()) 
		{
			JError::raise(2, 500, $model->getError(true) );
		}

		$this->setRedirect( 'index.php?option=com_vtemgallery&controller=vtemphoto&catid='.JRequest::getInt('catid').'&Itemid='.JRequest::getInt('Itemid'), JText::_( 'PHOTO DELETED' ) );
	}
	
	function swfUpload()
	{
		$catid = JRequest::getInt('catid', 0);
		$model = $this->getModel();
        
        if( !$model->authenticate('acl_upload', $catid) )
		{
			echo JText::_('RESTRICTED ACCESS');
		    return false;
		}
	    
	    $fileName = $_FILES['Filedata']['name'];
        $tmpPath = $_FILES['Filedata']['tmp_name'];
        $uploadError = $_FILES['Filedata']['error'];
        
	    if(! $fileData = igFileHelper::processUploadedImage($fileName, $tmpPath, $uploadError, 'vtemgallery_img', false) )
        {
            return false;
        }

        if (!$model->store($fileData) ) 
		{
			return false;
		}
	    
	    echo 1;
	}
	
	function plUpload()
	{
		$catid = JRequest::getInt('catid', 0);
		$model = $this->getModel();
		if( !$model->authenticate('acl_upload', $catid) )
		{
			echo JText::_('RESTRICTED ACCESS');
		    return false;
		}
		
		$fileName = $_FILES['file']['name'];
		$tmpPath = $_FILES['file']['tmp_name'];
		$uploadError = $_FILES['file']['error'];
		
		if(! $fileData = igFileHelper::processUploadedImage($fileName, $tmpPath, $uploadError, 'vtemgallery_img', false) )
		{
			return false;
		}
		
		$model = $this->getModel();
		
		if (!$model->store($fileData) ) 
		{
			return false;
		}
		
		echo 1;
	}
	
	function browserUpload()
	{
		$catid = JRequest::getInt('catid', 0);
		$model = $this->getModel();
		if( !$model->authenticate('acl_upload', $catid) )
		{
			echo JText::_('RESTRICTED ACCESS');
		    return false;
		}
	    
	    for($i=0; $i<count($_FILES['uploads']['name']); $i++)
	    {
	        $fileName = $_FILES['uploads']['name'][$i];
	        $tmpPath = $_FILES['uploads']['tmp_name'][$i];
	        $uploadError = $_FILES['uploads']['error'][$i];
	        
	        if(! $fileData = igFileHelper::processUploadedImage($fileName, $tmpPath, $uploadError, 'vtemgallery_img', true) )
            {
                return false;
            }
            
            $model = $this->getModel();
    
            if (!$model->store($fileData) ) 
    		{
    			return false;
    		}
	    }
	    
	    $moderateString = JRequest::getInt('moderateMsg', 0) == 1 ? '&moderateMsg=1' : '';

        $this->setRedirect('index.php?option=com_vtemgallery&controller=vtemphoto&catid='.JRequest::getInt('catid').'&Itemid='.JRequest::getInt('Itemid').$moderateString);
	}

	function publish()
	{
		$cid = JRequest::getVar('cid', array(0), '', 'array');
	    $model = $this->getModel();
        
        if( !$model->authenticate('acl_photo_publish', (int)$cid[0]) )
		{
			echo JText::_('RESTRICTED ACCESS');
		    return false;
		}
		
		if(!$model->publish(1)) 
		{
			JError::raiseError(2, 500, $model->getError(true) );
		}

		$this->setRedirect( 'index.php?option=com_vtemgallery&controller=vtemphoto&catid='.JRequest::getInt('catid').'&Itemid='.JRequest::getInt('Itemid') );
	}


	function unpublish()
	{
	    $cid = JRequest::getVar('cid', array(0), '', 'array');
	    $model = $this->getModel();
        
        if( !$model->authenticate('acl_photo_publish', (int)$cid[0]) )
		{
			echo JText::_('RESTRICTED ACCESS');
		    return false;
		}
		
		if(!$model->publish(0)) 
		{
			JError::raiseError(2, 500, $model->getError(true) );
		}

		$this->setRedirect( 'index.php?option=com_vtemgallery&controller=vtemphoto&catid='.JRequest::getInt('catid').'&Itemid='.JRequest::getInt('Itemid') );
	}
	
	function rotate()
	{
		$model = $this->getModel();
		
		if( !$model->authenticate('acl_photo_edit', JRequest::getInt('id') ) )
		{
			echo JText::_('RESTRICTED ACCESS');
		    return false;
		}
		
		if( !$model->rotate() ) 
		{
			$msg = '';
			JError::raise(2, 500, $model->getError() );
		}
		
		$this->setRedirect('index.php?option=com_vtemgallery&controller=vtemphoto&catid='.JRequest::getInt('catid'));
	}
	
	function addHit()
	{
		$id = JRequest::getInt('id',0);
		$model = $this->getModel();
	
		if( !$model->addHit($id) ) 
		{
			echo $model->getError();
		}
		else
		{
			echo 1;
		}
	}
	
	function saveorder()
	{
	    $model = $this->getModel();
	    $cid = JRequest::getVar('cid', array(0), '', 'array');
	    
	    for($i=0; $i<count($cid); $i++)
	    {
	        if( !$model->authenticate('acl_photo_ordering', (int)$cid[$i]) )
			{
				echo JText::_('RESTRICTED ACCESS');
			    return false;
			}
	    }
	    
		if(!$model->saveorder()) 
		{
			JError::raiseError(2, 500, $model->getError(true) );
		}

		$msg = JText::_( 'New ordering saved' );
		$this->setRedirect( 'index.php?option=com_vtemgallery&controller=vtemphoto&view=vtemphoto&catid='.JRequest::getInt('catid').'&Itemid='.JRequest::getInt('Itemid'), $msg );
	}
	
	function reportImage()
	{
		$model = $this->getModel();
	
		if( !$model->reportImage() ) 
		{
			JError::raise(2, 500, $model->getError() );
			$msg = '';
		}
		else
		{
			$msg = JText::_('YOUR MESSAGE SENT');
		}
		
		$this->setRedirect('index.php?option=com_vtemgallery&view=vtemcategory&id='.JRequest::getInt('catid'), $msg);
	}
	
}	